#ifndef _CALIBRATIONMANAGER_HH_
#define _CALIBRATIONMANAGER_HH_

#include <iostream>
#include <vector>

#include <TTree.h>

using namespace std;

class CalibrationManager
{
  private:
    TString file_name;
    TString detector_name;
    Int_t detector_id;

  public:
    CalibrationManager(){}
    CalibrationManager(TString det_name, TString cname){
      detector_name = det_name;
      file_name = cname;
      ReadCalibration();
    }
    ~CalibrationManager(){}

    Int_t dim;
    vector< vector<Double_t> > parameters; //parameters[branches][dims]
    vector<TString> branch_name;
    vector< vector<Double_t> > position_prms; //parameters[MUX_id][boundary=17]

    void SetDetectorId();
    Double_t GetCalibrateValue(Int_t id, Int_t branch_id, Int_t ch);

    void ReadCalibration();
    void ReadMUXposCalib(TString pos_file_name);
};

#endif
