#ifndef _CHANNELMAP_HH_
#define _CHANNELMAP_HH_

#include <iostream>
#include <fstream>
#include <string>

#include <TTree.h>

using namespace std;


class ChannelMap
{
  private:
    TString filename;

  public:
    ChannelMap(){}
    ChannelMap(TString in_filename){
      filename = in_filename;
      ReadMap();
    }
    ~ChannelMap(){}

    Int_t size = 0;
    vector< vector<Int_t> > segment_id;
    vector< vector<Int_t> > channel;
    vector<TString> detector_name;

    void SetMapFile(TString in_filename){ filename = in_filename; }

    TString GetMap(){ return filename;}
    Int_t GetSize(){ return size; }

    void ReadMap();
    void ReadMap(TString in_filename);
};

#endif
